local mods, actorCmds

return Def.ActorFrame {
	InitCommand = function(self)
	end,

	OnCommand = function(self)
		local screen = SCREENMAN:GetTopScreen()

		local null = self:GetChild('NullActorFrame')

		local p1 = screen:GetChild('PlayerP1')
		local p2 = screen:GetChild('PlayerP2') or null

		if not p1 then
			for i,v in pairs(screen:GetChild('')) do
				if tostring(v):find('Player') then
					p1 = v
					break
				end
			end
		end

		local players = {p1, p2}

		local p1state = GAMESTATE:GetPlayerState(PLAYER_1)
		local p2state = GAMESTATE:GetPlayerState(PLAYER_2)

		local bampyOn = '*10 250% bumpy'
		local bampyOff = '*99 no bumpy'
		
		local yes = '*4 99999999999999999999999999% reverse'
		local no = '*9999 no reverse'

		local flepOn = '*99 flip'
		local flepOff = '*99 no flip'
		
		local beatDist = '*4 250% distant'
		local beatHall = '*4 250% hallway'
		local offAll = '*99 overhead'

		local bumBumbum = '*99 250% beat'
		local bumOff = '*99 no beat'

		local stuffIdk = '*99 2000% dizzy'
		local stuffOff = '*1000 no dizzy'

		local whiteOff = '*99 no stealth'
		local whiteOn = '*99 55% stealth'

		local bumpUp = '*20 250% drunk'
		local bumpDown = '*20 -250% drunk'
		local bumpFuck = '*9999 no drunk'

		local introShit = '*99 2x,*99 cover,*99 blind'
		
		local whuteOn = '*4 55% stealth,*4 -100% tornado'
		local whuteOff = '*99 no stealth,*99 no tornado'
		
		local bampUp = '*99 -200% tiny'
		local bampFuck = '*10 no tiny'

		mods = {
			{0, introShit},
			{36, bumpFuck},
			{68, whiteOn},
			{84, whiteOff},
			{92, bumBumbum, bumpFuck, whiteOn},
			{120, whiteOff},
			{124, bumpFuck, stuffOff},
			{188, whiteOn},
			{204, bampyOn},
			{220, bampyOff, whiteOff},
			{300, yes},
			{316.1, whuteOn},
			{412, no, bumpDown, whuteOff},
			{444, bampUp},
			{444.25, bampFuck},
			{604, yes},
			{636, no},
			--'em devils
			{666, '*4 -300% tiny,dark,stealth'},
			{668, '*4 200% tiny,*4 200% mini'},
			{692, '*99 no cover'},
			{716, '*99 cover'}
		}
		
for beat=28,35, 1 do
	table.insert(mods, {beat, bumpUp})
	table.insert(mods, {beat + 0.25, bumpDown})
	table.insert(mods, {beat + 0.5, bumpUp})
	table.insert(mods, {beat + 0.75, bumpDown})
end

for beat=152,155, 1 do
	table.insert(mods, {beat, flepOn})
	table.insert(mods, {beat + 0.25, flepOff})
	table.insert(mods, {beat + 0.5, flepOn})
	table.insert(mods, {beat + 0.75, flepOff})
end

for beat=36,67, 1 do
	table.insert(mods, {beat, whiteOn})
	table.insert(mods, {beat + 0.25, whiteOff})
	table.insert(mods, {beat + 0.5, whiteOn})
	table.insert(mods, {beat + 0.75, whiteOff})
end

for beat=68,83, 2 do
	table.insert(mods, {beat, flepOn})
	table.insert(mods, {beat + 1.5, flepOff})
end

laggg={{84,91},{120,123}}

for i,v in pairs(laggg) do
    for beat=v[1],v[2] do
        table.insert(mods, {beat, bumpUp})
		table.insert(mods, {beat + 0.167, bumpDown})
		table.insert(mods, {beat + 0.333, bumpUp})
		table.insert(mods, {beat + 0.5, bumpDown})
		table.insert(mods, {beat + 0.667, bumpUp})
		table.insert(mods, {beat + 0.833, bumpDown})
    end
end

for beat=92,119, 3.25 do
	table.insert(mods, {beat, stuffOff})
	table.insert(mods, {beat + 0.75, stuffIdk})
end

for beat=456,461, 1 do
	table.insert(mods, {beat, bampUp})
	table.insert(mods, {beat + 0.25, bampFuck})
end

BAMPS={{290.5,291.5},{450.5,451.5},{466.5,467.5}}

for i,v in pairs(BAMPS) do
    for beat=v[1],v[2] do
        table.insert(mods, {beat, bampUp})
		table.insert(mods, {beat + 0.25, bampFuck})
		table.insert(mods, {beat + 0.5, bampUp})
		table.insert(mods, {beat + 0.75, bampFuck})
    end
end


		local introWag = function()
			p1:wag():effectmagnitude(0, 0, 20):effectclock('beat'):effectperiod(10)
			p2:wag():effectmagnitude(0, 0, 20):effectclock('beat'):effectperiod(10)
		end

		local stopEffect = function()
			p1:stopeffect()
			p2:stopeffect()
		end
		
		local stopScreen = function()
			screen:stopeffect()
		end

		local wug = function()
			for i=1, #players do
				players[i]
					:wag()
					:effectmagnitude(45, 0, 0)
					:effectclock('beat')
					:effectperiod(2)
			end
		end
		
		local CenterPlyrs = function()
			for i=1, #players do
				players[i]
					:x(SCREEN_CENTER_X)
			end
		end
		
		local wugg = function()
			for i=1, #players do
				players[i]
					:wag()
					:effectmagnitude(0, 0, 45)
					:effectclock('beat')
					:effectperiod(2)
			end
		end

		local spun = function()
			for i=1, #players do
				players[i]
					:wag()
					:effectmagnitude(0, 360, 0)
					:effectclock('beat')
					:effectperiod(2)
			end
		end

		local yeah = function()
			for i=1, #players do
				players[i]
					:smooth(1)
					:x(SCREEN_WIDTH/4)
			end
		end
		
		local yeah2 = function()
			for i=1, #players do
				players[i]
					:smooth(1)
					:x(SCREEN_WIDTH*3/4)
			end
		end

		local yay = function()
			screen:bob():effectmagnitude(69, 0, 69):effectclock('beat'):effectperiod(2)
		end
		
		local screenVib = function()
			screen:vibrate()
		end

		actorCmds = {
			{0.1, introWag},
			{0.101, CenterPlyrs},
			{68, stopEffect},
			{124, wug},
			{152, stopEffect},
			{156, wugg},
			{188, introWag},
			{220, spun},
			{376, screenVib},
			{380, stopScreen},
			{412, stopEffect},
			{444, introWag},
			{472, function()
				for i=1, #players do
					players[i]
						:bob()
						:effectmagnitude(420, 0, 420)
						:effectperiod(0.01)
				end
			end},
			{474, function()
				for i=1, #players do
					players[i]
						:bob()
						:effectmagnitude(0, 420, 0)
						:effectperiod(0.01)
				end
			end},
			{476, yay},
			{476.1, spun},
			{636, stopScreen},
			{660, stopEffect}
		}
		
for beat=252,258, 1 do
	table.insert(actorCmds, {beat, yeah})
	table.insert(actorCmds, {beat + 0.5, yeah2})
end

for beat=540,548, 1 do
	table.insert(actorCmds, {beat, yeah})
	table.insert(actorCmds, {beat + 0.5, yeah2})
end

		-- for edit mode
		-- for i=#mods, 1, -1 do
		-- 	if GAMESTATE:GetSongBeat() > mods[i][1] then
		-- 		table.remove(mods, i)
		-- 	end
		-- end

		for i=#actorCmds, 1, -1 do
			if GAMESTATE:GetSongBeat() > actorCmds[i][1] then
				table.remove(actorCmds, i)
			end
		end

		p1:stopeffect()
		p2:stopeffect()

		local firstRun = true
		self:SetUpdateFunction(function(self, delta)
			local currentBeat = GAMESTATE:GetSongBeat()

			for i=1, #mods do
				local mod = mods[i]
				if not mod.done and currentBeat >= mod[1] then
					local modstr = table.concat({ unpack(mod, 2) }, ',')
					p1state:SetPlayerOptions('ModsLevel_Song', p1state:GetPlayerOptionsString('ModsLevel_Song')..','..modstr)
					p2state:SetPlayerOptions('ModsLevel_Song', p2state:GetPlayerOptionsString('ModsLevel_Song')..','..modstr)
					mod.done = true

					-- this is horrible, like, no
					-- only keeping for historical purposes
					-- for modname, values in pairs(mod) do
					-- 	if p1options[modname] then
					-- 		p1options[modname](p1options, unpack(values))
					-- 		p2options[modname](p2options, unpack(values))
					-- 	end
					-- end

					if not firstRun then
						break
					end
				end
			end

			for i=1, #actorCmds do
				local command = actorCmds[i]
				if not command.done and currentBeat > command[1] then
					command[2]()
					command.done = true
				end
			end
			
			for i=1,2 do
				SCREENMAN:GetTopScreen():GetChild('LifeP'..i):visible(false);
                SCREENMAN:GetTopScreen():GetChild('ScoreP'..i):visible(false);
				SCREENMAN:GetTopScreen():GetChild('Overlay'):visible(false);
				SCREENMAN:GetTopScreen():GetChild('Underlay'):visible(false);
				SCREENMAN:GetTopScreen():GetChild('BPMDisplay'):visible(false);
				SCREENMAN:GetTopScreen():GetChild('StageDisplay'):visible(false);
				SCREENMAN:GetTopScreen():GetChild('SongTitle'):visible(false);
				SCREENMAN:GetTopScreen():GetChild("SongMeterDisplay" .. PlayerNumberToString(i-1)):visible(false);
				SCREENMAN:GetTopScreen():GetChild("StepsDisplay" .. PlayerNumberToString(i-1)):visible(false);
			end

			if firstRun then
				p1:finishtweening()
				p2:finishtweening()
			end
			firstRun = false
		end)
	end,
	
	Def.Sprite{
    InitCommand= cmd(hibernate,158.5;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomtowidth,SCREEN_WIDTH;zoomtoheight,SCREEN_HEIGHT;rainbow,1;blend,'add'),
    OnCommand= cmd(sleep,61.5;diffusealpha,0),
    Texture= "yus.png",
  },
  
	Def.Sprite{
    InitCommand= cmd(hibernate,114.4;x,SCREEN_WIDTH*3/4;y,SCREEN_CENTER_Y;wag,1;effectperiod,0.25),
    OnCommand= cmd(sleep,1.5;diffusealpha,0),
    Texture= "zuro.png",
  },
  
	Def.Sprite{
    InitCommand= cmd(x,SCREEN_CENTER_X+400;y,SCREEN_CENTER_Y;hibernate,125.5;decelerate,2.5;x,SCREEN_CENTER_X+100;bob,1;effectclock,'bgm';effectmagnitude,69,0,69;),
    OnCommand= cmd(sleep,9;diffusealpha,0),
    Texture= "heh.png",
  },

	Def.Quad{ OnCommand = function(self) self:sleep(1000) end },
	Def.ActorFrame{ Name='NullActorFrame' },
}
